import 'dart:core';
import 'package:firestore_repository/firestore_repository.dart';

class ActivityStatus {
  static const Text = 1;
  static const Image = 2;
  // static const Status = 4;
  // static const Proposal = 8;
  //todo add more statuses
}

class SeenStatus {
  static const Sent = 0;
  static const Recieved = 1;
  static const Seen = 2;
  //todo add more statuses
}

class ActivityLog extends FirebaseModel {
  late final String? userId;
  late final int activityStatus;
  late final int seenStatus;
  late final List<String> seenBy;
  late final DateTime timestamp;
  late final String path;
  late final String documentId;

  ActivityLog.fromSnapshot(DocumentSnapshot<Map<String, dynamic>> snapshot) : super.fromSnapshot(snapshot) {
    documentId = snapshot.id;
    var data = snapshot.data() as Map<String, Object?>;
    userId = data["userId"]! as String;
    seenStatus = data["seenStatus"]! as int;
    seenBy = List<String>.from((data["seenBy"] as Iterable?) ?? []);
    timestamp = (data["timestamp"] as Timestamp).toDate();
    activityStatus = data["activityStatus"]! as int;
    path = snapshot.reference.path;
  }

  ActivityLog({required this.activityStatus, required this.userId, required String documentId})
      : super(documentId, null) {
    this.seenStatus = SeenStatus.Sent;
    this.seenBy = [];
  }

  @override
  Map<String, Object?> toJson() {
    var json = super.toJson();
    json['userId'] = userId;
    // json['idTo'] = idTo;
    json['seenStatus'] = seenStatus;
    json['seenBy'] = seenBy;
    json['timestamp'] = DateTime.now();
    json['activityStatus'] = activityStatus;
    return json;
  }

  @override
  bool operator ==(Object o) {
    if (identical(this, o)) return true;

    return o is ActivityLog && o.path == path;
  }

  @override
  int get hashCode {
    return path.hashCode;
  }
}
