import 'activitylog.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

class ImageActivity extends ActivityLog {
  late final String? imagePath;
  late final String? thumbPath;
  ImageActivity.fromSnapshot(DocumentSnapshot<Map<String, dynamic>> snapshot) : super.fromSnapshot(snapshot) {
    var json = snapshot.data() as Map<String, Object?>;
    imagePath = json["imagePath"] as String;
    thumbPath = json["thumbPath"] as String?;
  }

  ImageActivity({required String documentId, this.imagePath, this.thumbPath, String? userId})
      : super(activityStatus: ActivityStatus.Image, userId: userId, documentId: documentId);

  @override
  Map<String, Object?> toJson() {
    var json = super.toJson();
    json['imagePath'] = imagePath;
    json['thumbPath'] = thumbPath;

    return json;
  }
}
