import 'activitylog.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

class TextActivity extends ActivityLog {
  late final String text;
  TextActivity.fromSnapshot(DocumentSnapshot<Map<String, dynamic>> snap) : super.fromSnapshot(snap) {
    var json = snap.data() as Map<String, Object?>;
    text = json["text"] as String;
  }

  TextActivity({required String documentId, required this.text, String? userId})
      : super(activityStatus: ActivityStatus.Text, userId: userId, documentId: documentId);

  @override
  Map<String, Object?> toJson() {
    var json = super.toJson();
    json['text'] = text;
    return json;
  }
}
