import 'package:firestore_repository/firestore_repository.dart';

class ChatModel extends FirebaseModel {
  late final List<String> users;
  late final DocumentReference<Map<String, Object?>>? lastMessageReference;
  late final String? path;
  late final String? title;
  // ChatModel({this.users, this.path, this.lastMessageReference, this.title}) : super("", null);

  ChatModel.fromSnapshot(DocumentSnapshot<Map<String, Object?>> snapshot) : super.fromSnapshot(snapshot) {
    var data = snapshot.data()!;
    this.users = List<String>.from((data["users"] as Iterable?) ?? []);
    this.lastMessageReference = data["lastMessage"] as DocumentReference<Map<String, dynamic>>?;
    this.path = snapshot.reference.path;
    this.title = data["title"] as String?;
  }

  @override
  Map<String, Object?> toJson() {
    var map = super.toJson();
    map['users'] = users;
    map['title'] = title;
    return map;
  }
}
